hdu 6319 Problem A. Ascending Rating

Problem Description

Before the start of contest, there are n ICPC contestants waiting in a long queue. They are labeled by 1 to n from left to right. It can be easily found that the i-th contestant's QodeForces rating is ai.
Little Q, the coach of Quailty Normal University, is bored to just watch them waiting in the queue. He starts to compare the rating of the contestants. He will pick a continous interval with length m, say [l,l+m−1], and then inspect each contestant from left to right. Initially, he will write down two numbers maxrating=−1 and count=0. Everytime he meets a contestant k with strictly higher rating than maxrating, he will change maxrating to ak and count to count+1.
Little T is also a coach waiting for the contest. He knows Little Q is not good at counting, so he is wondering what are the correct final value of maxrating and count. Please write a program to figure out the answer.

Input

The first line of the input contains an integer T(1≤T≤2000), denoting the number of test cases.
In each test case, there are 7 integers n,m,k,p,q,r,MOD(1≤m,k≤n≤107,5≤p,q,r,MOD≤109) in the first line, denoting the number of contestants, the length of interval, and the parameters k,p,q,r,MOD.
In the next line, there are k integers a1,a2,...,ak(0≤ai≤109), denoting the rating of the first k contestants.
To reduce the large input, we will use the following generator. The numbers p,q,r and MOD are given initially. The values ai(k<i≤n) are then produced as follows :

ai=(p×ai−1+q×i+r)modMOD
It is guaranteed that ∑n≤7×107 and ∑k≤2×106.

Output

Since the output file may be very large, let's denote maxratingi and counti as the result of interval [i,i+m−1].
For each test case, you need to print a single line containing two integers A and B, where :

AB==∑i=1n−m+1(maxratingi⊕i)∑i=1n−m+1(counti⊕i)
Note that ``⊕'' denotes binary XOR operation.

题意:

有 t 组数据,定义一个长度为 n 的区间,对于这个区间先给你前面 k 个数,后面 k + 1 到 n 个数由公式 a[i] = (p * a[i - 1] + q * i + r) % mod  来求。定义长度为 m、 区间范围为 [ i ,i + m - 1 ] 的 n - m + 1 个子区间 ,求A :每个区间 的最大值 ^ i 的和。

B :每个区间 的最大值改变次数 ^ i 的和(比如某个区间 :2 , 3, 1 ,6, 4, 7 。题意说刚开始最大值为0; 遇到 2 、3、6、7。最大值改变了4 次 ,所以count = 4)。

吐槽(如果你是来学习的,可以不用看):

嘤嘤嘤嘤,刚开始花了很长的时间来读懂题意,必须得用O(n)的时间复杂度来做,毕竟 10 ^ 7 不是开玩笑的。

然后我想了很久想不出来。然后学长跟我说这道题 这个max 容易求(递推区间的最大值可以用单调队列,具体参考POJ2823),主要是这个max的改变次数不容易,暂时想不出来。完了学长有思路了就说:对哦,能不能用单调队列反过来求 ? 然后我想了五秒(怎么可以那时间复杂度可是O (n ^ 2 )(那时我不知道递推区间的最大值可以用单调队列)),“不行”。然后有点急来不及解释就去上次所了。之后也就忘了解释。 (记一次严重gank学长思路)。赛后被学长怼死了 。。。。。。嘤嘤嘤嘤

正确思路 :

从n 到 1 倒着遍历数组。

每次遇到比当前这一位小的数就从队尾抛出。把这个数然后从队尾压入队列。如果队列长度超过 m ,从队头抛出数(注意上面都是对a[i] 的下标进行操作)。

这样的话,队首元素就是最大值,队列长度就是变化次数(因为每次逆向开始构造,存储的数比当前的数大,顺着看就是遇到了一个比当前数大的元素,变化次数就加一)。

然后弄个ans  记录下答案就行了。

注意的细节:p * a[ i - 1 ] 可能会爆int 。前面加个1ll 就行了。

 

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值